
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Mastering_presetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const mastering_presets = await db.mastering_presets.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        target: data.target
        ||
        null
            ,
            
        lufs_target: data.lufs_target
        ||
        null
            ,
            
        true_peak_db: data.true_peak_db
        ||
        null
            ,
            
        is_default: data.is_default
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await mastering_presets.setGenre( data.genre || null, {
            transaction,
        });
        
        await mastering_presets.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return mastering_presets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const mastering_presetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                target: item.target
            ||
            null
            ,
            
                lufs_target: item.lufs_target
            ||
            null
            ,
            
                true_peak_db: item.true_peak_db
            ||
            null
            ,
            
                is_default: item.is_default
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const mastering_presets = await db.mastering_presets.bulkCreate(mastering_presetsData, { transaction });

        // For each item created, replace relation files
        

        return mastering_presets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const mastering_presets = await db.mastering_presets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.target !== undefined) updatePayload.target = data.target;
        
        
        if (data.lufs_target !== undefined) updatePayload.lufs_target = data.lufs_target;
        
        
        if (data.true_peak_db !== undefined) updatePayload.true_peak_db = data.true_peak_db;
        
        
        if (data.is_default !== undefined) updatePayload.is_default = data.is_default;
        
        
        updatePayload.updatedById = currentUser.id;

        await mastering_presets.update(updatePayload, {transaction});

        
        
        if (data.genre !== undefined) {
            await mastering_presets.setGenre(
              
              data.genre,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await mastering_presets.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return mastering_presets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const mastering_presets = await db.mastering_presets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of mastering_presets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of mastering_presets) {
                await record.destroy({transaction});
            }
        });


        return mastering_presets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const mastering_presets = await db.mastering_presets.findByPk(id, options);

        await mastering_presets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await mastering_presets.destroy({
            transaction
        });

        return mastering_presets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const mastering_presets = await db.mastering_presets.findOne(
            { where },
            { transaction },
        );

        if (!mastering_presets) {
            return mastering_presets;
        }

        const output = mastering_presets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.mastering_sessions_preset = await mastering_presets.getMastering_sessions_preset({
            transaction
        });
        
        
        
        
        
        
        
        output.genre = await mastering_presets.getGenre({
            transaction
        });
        
        
        output.organizations = await mastering_presets.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.genres,
        as: 'genre',
        
        where: filter.genre ? {
          [Op.or]: [
            { id: { [Op.in]: filter.genre.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.genre.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'mastering_presets',
                        'name',
                        filter.name,
                    ),
                };
            }
            

            
            

            
            if (filter.lufs_targetRange) {
                const [start, end] = filter.lufs_targetRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    lufs_target: {
                    ...where.lufs_target,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    lufs_target: {
                    ...where.lufs_target,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.true_peak_dbRange) {
                const [start, end] = filter.true_peak_dbRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    true_peak_db: {
                    ...where.true_peak_db,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    true_peak_db: {
                    ...where.true_peak_db,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.target) {
                where = {
                    ...where,
                target: filter.target,
            };
            }
            
            if (filter.is_default) {
                where = {
                    ...where,
                is_default: filter.is_default,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.mastering_presets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'mastering_presets',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.mastering_presets.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

